Change the cron script (btw. we are now triggered by systemd timers)
[can-benchmark.git] / gw-tests / lib.sh
1 set -e
2
3 COUNT=10000
4
5 OPT_TRAFFIC=oneatatime
6 OPT_LOAD=none
7
8 error() {
9     echo $1 >&2
10     exit 1
11 }
12
13 while [ $# -gt 0 ]; do
14     case "$1" in
15         -P|--no-plot) OPT_PLOT_DISABLE=1; shift;;
16         -p|--plot) OPT_PLOT_ONLY=1; shift;;
17         -X|--no-x11-plot) OPT_NO_X11=1; shift;;
18         -t) case "$2" in
19                 all|flood|50|oneatatime) OPT_TRAFFIC=$2;;
20                 *) error "Unknown traffic specification: $2";;
21             esac;
22             shift 2;;
23         -l) case "$2" in
24                 all|none|cpu|eth|can) OPT_LOAD=$2;;
25                 *) error "Unknown load specification: $2";;
26             esac;
27             shift 2;;
28         -u) OPT_UPDATE=1; shift;;
29     esac
30 done
31
32 PATH=$PWD/../_compiled/bin/:$PATH
33
34 sshgw() {
35     local socket="$HOME/.ssh/cangw-connection"
36
37     if [[ "$1" = "-f" ]]; then
38             shift
39     else
40         if [[ "$NO_GW_NEEDED" ]]; then return; fi
41     fi
42
43     if [[ ! -S $socket ]] || ! ssh -x -a -S $socket root@192.168.2.3 true; then
44         # Create master connection to speed up subsequenct command.
45         ssh -N -f -M -S $socket root@192.168.2.3 >/dev/null 2>&1
46     fi
47     ssh -x -a -S $socket root@192.168.2.3 "$@"
48 }
49
50 cleanupgw() {
51     sshgw 'cangw -F'
52 }
53
54 _plot() {
55     local testname=`basename $0 .sh`
56     rm -rf *.pdf *.png
57     for i in "" $ADDITIONAL_PLOTS; do
58         plot_cmds $i | sed -e "/set title/ s/[\"']\(.*\)[\"']/\"\1\\\\n{\/*0.75 (GW kernel $kvers, Traffic $traffic, Load $load)}\"/" > plot$i.gp
59         if [[ ! -s plot$i.gp ]]; then continue; fi
60         if [ -z "$OPT_NO_X11" ]; then
61             echo "set terminal x11 enhanced; $(< plot$i.gp)" | gnuplot -persist
62         fi
63         test "$(gnuplot --version)" = "gnuplot 4.2 patchlevel 5 " && continue
64         echo "set terminal pdfcairo dashed color enhanced; " \
65              "set output \"graph$i.pdf\";" \
66              "set pointsize 0.5;" \
67             "$(< plot$i.gp)" |sed -e 's/lc [0-9]//'| gnuplot
68         echo 'set terminal pngcairo color enhanced size 750,525 font ",10" ;' \
69             "$(< plot$i.gp)" | gnuplot > graph$i.png
70         convert -resize 150x105 -gamma 0.5 -quality 90 -type Palette -depth 8 graph$i.png tgraph$i.png
71 #     echo 'set terminal pngcairo color enhanced size 150,105 font ",1";' \
72 #       "$(< plot.gp)" | gnuplot > thumb/${testname}$i.png
73     done
74 }
75
76 echo_plot() {
77     plot=$1
78     [[ "$_plot_separator" ]] && echo ", \\"
79     _plot_separator=t
80     echo -n "    " $plot
81 }
82
83 traffic_and_length() {
84     local opts
85     case $traffic in
86         flood) opts='';;
87         50)        opts="-p $((2*(44+$1*8)))";;
88         oneatatime)        opts="-o";;
89         *) error "Unknown traffic specification: $traffic"
90     esac
91     echo $opts -l $1
92 }
93
94 start_load() {
95     unset LATESTER_CONTROL_HACKBENCH
96     case $load in
97         none) ;;
98         cpu) export LATESTER_CONTROL_HACKBENCH=$(sshgw 'nohup setpgid hackbench -g 3 -l 100000  >/dev/null & echo $!');;
99         eth) ping -f -s 60000 -q 192.168.2.3 & loadpid=$!;; # TODO: Generate eth load from another computer
100         can) latester -q -d can1 -i 0x7ff & loadpid=$!;;
101         *) error "Unknown load specification: $load"
102     esac
103 }
104
105 kill_load() {
106     case $load in
107         none) ;;
108         cpu) sshgw "kill -9 -$LATESTER_CONTROL_HACKBENCH; killall -q -9 hackbench || :";;
109         eth) kill $loadpid;;
110         can) kill $loadpid;;
111         *) error "Unknown load specification: $load"
112     esac
113 }
114
115 _measure() {
116     if [[ "$OPT_UPDATE" && -f plot.sh && ( plot.sh -nt $test.sh ) ]]; then echo "skiping: up-to-date"; return; fi
117     # Remove data from the last measurement
118     rm -rf *
119     # Kill load generators left possibly from the past runs
120     killall -q ping || :
121     killall -q latester || :
122     if [[ ! "$NO_GW_NEEDED" ]]; then
123         sshgw 'killall -q hackbench || :'
124         # Set can interfaces up
125         sshgw 'for i in 0 1; do ip link show dev can$i|grep -q UP || ip link set can$i up type can bitrate 1000000; done'
126         # Delete all vcan interfaces
127         sshgw 'for dev in $(ip l|grep -o vcan[^:]\\+); do ip link del dev $dev; done'
128         # Reset priorities
129         sshgw 'if pid=`pidof irq/145-can0`; then chrt -p -f 50 $pid > /dev/null; fi'
130         sshgw 'if pid=`pidof irq/146-can1`; then chrt -p -f 50 $pid > /dev/null; fi'
131         sshgw 'if pid=`pidof sirq-net-rx/0`; then chrt -p -f 49 $pid > /dev/null; fi'
132         sshgw 'if pid=`pidof sirq-net-tx/0`; then chrt -p -f 49 $pid > /dev/null; fi'
133         # Set the length of qdisc queue to avoid ENOBUFS errors
134         sshgw 'ifconfig can0 txqueuelen 1000; ifconfig can1 txqueuelen 1000'
135         ifconfig can0 txqueuelen 200
136         ifconfig can1 txqueuelen 200
137         cleanupgw
138
139         type prepare >/dev/null 2>&1 && prepare || :
140         start_load
141     fi
142
143     main
144
145     if [[ ! "$NO_GW_NEEDED" ]]; then
146         kill_load
147     fi
148
149     if [ ! "$SKIPPED" ]; then
150         # Create a plot script at the end to signalize that the
151         # measurement was successfully finished
152         cat > plot.sh <<-EOF
153         #!/bin/bash
154         export kvers=$kvers
155         export hostkvers=$hostkvers
156         export traffic=$traffic
157         export load=$load
158         cd \$(dirname \$0)/$(dirname $script)
159         exec ./$(basename $script) --plot "\$@"
160         EOF
161         chmod +x plot.sh
162     fi
163 }
164
165
166 _run() {
167     if [[ $OPT_TRAFFIC = all ]]
168     then traffics="flood 50 oneatatime"
169     else traffics=${traffic:-$OPT_TRAFFIC}
170     fi
171     if [[ $OPT_LOAD = all ]]
172     then loads="none cpu eth" # TODO: can
173     else loads=${load:-$OPT_LOAD}
174     fi
175     hostkvers=${hostkvers:-host-$(uname -r)}
176     kvers=${kvers:-$(sshgw -f uname -r)}
177     test=$(basename $0 .sh)
178     for load in $loads; do
179     for traffic in $traffics; do
180         dir="results/$hostkvers/$kvers/$traffic/$load/$test"
181         mkdir -p $dir
182         script=$(echo $dir | sed -e 's/[^/]*/../g')/${test}.sh
183         cd $dir
184         if [[ ! "$OPT_PLOT_ONLY" ]]; then
185             echo "Working directory: $dir"
186             _measure
187         fi
188         if [[ ! "$OPT_PLOT_DISABLE" ]]; then
189             _plot
190         fi
191         cd - > /dev/null
192     done
193     done
194 }
195
196 test_end() {
197     test_end_called=t
198     exit_ok=
199     _run
200     exit_ok=t
201 }
202
203 _myexit() {
204     code=$?
205     cmd=$BASH_COMMAND
206     if [[ ! "$test_end_called" ]]; then
207         test_end_called=t
208         error "bug in the test script: No test_end called"
209     fi
210     if ! test -n "$exit_ok"; then
211         error "FATAL: Command '$cmd' exit with code $code"
212     fi
213 }
214
215 trap '_myexit' EXIT